Blame


1 c4296144 2019-05-09 stsp #!/bin/sh
2 c4296144 2019-05-09 stsp #
3 c4296144 2019-05-09 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 c4296144 2019-05-09 stsp #
5 c4296144 2019-05-09 stsp # Permission to use, copy, modify, and distribute this software for any
6 c4296144 2019-05-09 stsp # purpose with or without fee is hereby granted, provided that the above
7 c4296144 2019-05-09 stsp # copyright notice and this permission notice appear in all copies.
8 c4296144 2019-05-09 stsp #
9 c4296144 2019-05-09 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 c4296144 2019-05-09 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 c4296144 2019-05-09 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 c4296144 2019-05-09 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 c4296144 2019-05-09 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 c4296144 2019-05-09 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 c4296144 2019-05-09 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 c4296144 2019-05-09 stsp
17 c4296144 2019-05-09 stsp . ./common.sh
18 c4296144 2019-05-09 stsp
19 c4296144 2019-05-09 stsp function test_commit_basic {
20 c4296144 2019-05-09 stsp local testroot=`test_init commit_basic`
21 c4296144 2019-05-09 stsp
22 c4296144 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
23 c4296144 2019-05-09 stsp ret="$?"
24 c4296144 2019-05-09 stsp if [ "$ret" != "0" ]; then
25 c4296144 2019-05-09 stsp test_done "$testroot" "$ret"
26 c4296144 2019-05-09 stsp return 1
27 c4296144 2019-05-09 stsp fi
28 c4296144 2019-05-09 stsp
29 c4296144 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
30 c4296144 2019-05-09 stsp (cd $testroot/wt && got rm beta >/dev/null)
31 c4296144 2019-05-09 stsp echo "new file" > $testroot/wt/new
32 c4296144 2019-05-09 stsp (cd $testroot/wt && got add new >/dev/null)
33 c4296144 2019-05-09 stsp
34 83a7ae6d 2019-05-10 stsp (cd $testroot/wt && got commit -m 'test commit_basic' > $testroot/stdout)
35 c4296144 2019-05-09 stsp
36 c4296144 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
37 afa376bf 2019-05-09 stsp echo "A new" > $testroot/stdout.expected
38 afa376bf 2019-05-09 stsp echo "M alpha" >> $testroot/stdout.expected
39 afa376bf 2019-05-09 stsp echo "D beta" >> $testroot/stdout.expected
40 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
41 c4296144 2019-05-09 stsp
42 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
43 c4296144 2019-05-09 stsp ret="$?"
44 c4296144 2019-05-09 stsp if [ "$ret" != "0" ]; then
45 c4296144 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
46 c4296144 2019-05-09 stsp fi
47 c4296144 2019-05-09 stsp test_done "$testroot" "$ret"
48 c4296144 2019-05-09 stsp }
49 c4296144 2019-05-09 stsp
50 baa7dcfa 2019-05-09 stsp function test_commit_new_subdir {
51 baa7dcfa 2019-05-09 stsp local testroot=`test_init commit_new_subdir`
52 baa7dcfa 2019-05-09 stsp
53 baa7dcfa 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
54 baa7dcfa 2019-05-09 stsp ret="$?"
55 baa7dcfa 2019-05-09 stsp if [ "$ret" != "0" ]; then
56 baa7dcfa 2019-05-09 stsp test_done "$testroot" "$ret"
57 baa7dcfa 2019-05-09 stsp return 1
58 baa7dcfa 2019-05-09 stsp fi
59 baa7dcfa 2019-05-09 stsp
60 baa7dcfa 2019-05-09 stsp mkdir -p $testroot/wt/d
61 baa7dcfa 2019-05-09 stsp echo "new file" > $testroot/wt/d/new
62 baa7dcfa 2019-05-09 stsp echo "another new file" > $testroot/wt/d/new2
63 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && got add d/new >/dev/null)
64 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && got add d/new2 >/dev/null)
65 baa7dcfa 2019-05-09 stsp
66 baa7dcfa 2019-05-09 stsp (cd $testroot/wt && \
67 baa7dcfa 2019-05-09 stsp got commit -m 'test commit_new_subdir' > $testroot/stdout)
68 baa7dcfa 2019-05-09 stsp
69 baa7dcfa 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
70 baa7dcfa 2019-05-09 stsp echo "A d/new" > $testroot/stdout.expected
71 baa7dcfa 2019-05-09 stsp echo "A d/new2" >> $testroot/stdout.expected
72 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
73 baa7dcfa 2019-05-09 stsp
74 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
75 baa7dcfa 2019-05-09 stsp ret="$?"
76 baa7dcfa 2019-05-09 stsp if [ "$ret" != "0" ]; then
77 baa7dcfa 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
78 baa7dcfa 2019-05-09 stsp fi
79 baa7dcfa 2019-05-09 stsp test_done "$testroot" "$ret"
80 baa7dcfa 2019-05-09 stsp }
81 baa7dcfa 2019-05-09 stsp
82 bc70eb79 2019-05-09 stsp function test_commit_subdir {
83 bc70eb79 2019-05-09 stsp local testroot=`test_init commit_subdir`
84 bc70eb79 2019-05-09 stsp
85 bc70eb79 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
86 bc70eb79 2019-05-09 stsp ret="$?"
87 bc70eb79 2019-05-09 stsp if [ "$ret" != "0" ]; then
88 bc70eb79 2019-05-09 stsp test_done "$testroot" "$ret"
89 bc70eb79 2019-05-09 stsp return 1
90 bc70eb79 2019-05-09 stsp fi
91 bc70eb79 2019-05-09 stsp
92 bc70eb79 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
93 bc70eb79 2019-05-09 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
94 bc70eb79 2019-05-09 stsp
95 bc70eb79 2019-05-09 stsp (cd $testroot/wt && \
96 bc70eb79 2019-05-09 stsp got commit -m 'test commit_subdir' epsilon > $testroot/stdout)
97 bc70eb79 2019-05-09 stsp
98 bc70eb79 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
99 bc70eb79 2019-05-09 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
100 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
101 bc70eb79 2019-05-09 stsp
102 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
103 bc70eb79 2019-05-09 stsp ret="$?"
104 bc70eb79 2019-05-09 stsp if [ "$ret" != "0" ]; then
105 bc70eb79 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
106 bc70eb79 2019-05-09 stsp fi
107 bc70eb79 2019-05-09 stsp test_done "$testroot" "$ret"
108 bc70eb79 2019-05-09 stsp }
109 bc70eb79 2019-05-09 stsp
110 5bbcb68b 2019-05-09 stsp function test_commit_single_file {
111 5bbcb68b 2019-05-09 stsp local testroot=`test_init commit_single_file`
112 5bbcb68b 2019-05-09 stsp
113 5bbcb68b 2019-05-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
114 5bbcb68b 2019-05-09 stsp ret="$?"
115 5bbcb68b 2019-05-09 stsp if [ "$ret" != "0" ]; then
116 5bbcb68b 2019-05-09 stsp test_done "$testroot" "$ret"
117 5bbcb68b 2019-05-09 stsp return 1
118 5bbcb68b 2019-05-09 stsp fi
119 5bbcb68b 2019-05-09 stsp
120 5bbcb68b 2019-05-09 stsp echo "modified alpha" > $testroot/wt/alpha
121 5bbcb68b 2019-05-09 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
122 5bbcb68b 2019-05-09 stsp
123 1a36436d 2019-06-10 stsp (cd $testroot/wt && got commit -m 'changed zeta' epsilon/zeta \
124 5bbcb68b 2019-05-09 stsp > $testroot/stdout)
125 5bbcb68b 2019-05-09 stsp
126 5bbcb68b 2019-05-09 stsp local head_rev=`git_show_head $testroot/repo`
127 5bbcb68b 2019-05-09 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
128 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
129 5bbcb68b 2019-05-09 stsp
130 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
131 5bbcb68b 2019-05-09 stsp ret="$?"
132 5bbcb68b 2019-05-09 stsp if [ "$ret" != "0" ]; then
133 5bbcb68b 2019-05-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
134 5bbcb68b 2019-05-09 stsp fi
135 5bbcb68b 2019-05-09 stsp test_done "$testroot" "$ret"
136 5bbcb68b 2019-05-09 stsp }
137 5bbcb68b 2019-05-09 stsp
138 819f385b 2019-05-10 stsp function test_commit_out_of_date {
139 819f385b 2019-05-10 stsp local testroot=`test_init commit_out_of_date`
140 f0b75401 2019-08-03 stsp local first_commit=`git_show_head $testroot/repo`
141 819f385b 2019-05-10 stsp
142 819f385b 2019-05-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
143 819f385b 2019-05-10 stsp ret="$?"
144 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
145 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
146 819f385b 2019-05-10 stsp return 1
147 819f385b 2019-05-10 stsp fi
148 819f385b 2019-05-10 stsp
149 819f385b 2019-05-10 stsp echo "modified alpha" > $testroot/repo/alpha
150 819f385b 2019-05-10 stsp git_commit $testroot/repo -m "modified alpha"
151 819f385b 2019-05-10 stsp
152 819f385b 2019-05-10 stsp echo "modified alpha" > $testroot/wt/alpha
153 819f385b 2019-05-10 stsp
154 819f385b 2019-05-10 stsp (cd $testroot/wt && got commit -m 'test commit_out_of_date' \
155 819f385b 2019-05-10 stsp > $testroot/stdout 2> $testroot/stderr)
156 819f385b 2019-05-10 stsp
157 819f385b 2019-05-10 stsp echo -n > $testroot/stdout.expected
158 819f385b 2019-05-10 stsp echo "got: work tree must be updated before these" \
159 819f385b 2019-05-10 stsp "changes can be committed" > $testroot/stderr.expected
160 819f385b 2019-05-10 stsp
161 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
162 819f385b 2019-05-10 stsp ret="$?"
163 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
164 819f385b 2019-05-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
165 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
166 819f385b 2019-05-10 stsp return 1
167 819f385b 2019-05-10 stsp fi
168 819f385b 2019-05-10 stsp
169 8d301dd9 2019-05-14 stsp cmp -s $testroot/stderr.expected $testroot/stderr
170 819f385b 2019-05-10 stsp ret="$?"
171 819f385b 2019-05-10 stsp if [ "$ret" != "0" ]; then
172 819f385b 2019-05-10 stsp diff -u $testroot/stderr.expected $testroot/stderr
173 f0b75401 2019-08-03 stsp test_done "$testroot" "$ret"
174 f0b75401 2019-08-03 stsp return 1
175 819f385b 2019-05-10 stsp fi
176 f0b75401 2019-08-03 stsp
177 f0b75401 2019-08-03 stsp echo "alpha" > $testroot/repo/alpha
178 f0b75401 2019-08-03 stsp git_commit $testroot/repo -m "reset alpha contents"
179 f0b75401 2019-08-03 stsp (cd $testroot/wt && got update -c $first_commit > /dev/null)
180 f0b75401 2019-08-03 stsp
181 f0b75401 2019-08-03 stsp echo "modified alpha" > $testroot/wt/alpha
182 f0b75401 2019-08-03 stsp
183 f0b75401 2019-08-03 stsp (cd $testroot/wt && got commit -m 'changed alpha ' > $testroot/stdout)
184 f0b75401 2019-08-03 stsp ret="$?"
185 f0b75401 2019-08-03 stsp if [ "$ret" != "0" ]; then
186 f0b75401 2019-08-03 stsp echo "commit failed unexpectedly" >&2
187 f0b75401 2019-08-03 stsp test_done "$testroot" "1"
188 f0b75401 2019-08-03 stsp return 1
189 f0b75401 2019-08-03 stsp fi
190 f0b75401 2019-08-03 stsp
191 f0b75401 2019-08-03 stsp local head_rev=`git_show_head $testroot/repo`
192 f0b75401 2019-08-03 stsp echo "M alpha" > $testroot/stdout.expected
193 f0b75401 2019-08-03 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
194 f0b75401 2019-08-03 stsp cmp -s $testroot/stdout.expected $testroot/stdout
195 f0b75401 2019-08-03 stsp ret="$?"
196 f0b75401 2019-08-03 stsp if [ "$ret" != "0" ]; then
197 f0b75401 2019-08-03 stsp diff -u $testroot/stdout.expected $testroot/stdout
198 f0b75401 2019-08-03 stsp fi
199 819f385b 2019-05-10 stsp test_done "$testroot" "$ret"
200 819f385b 2019-05-10 stsp }
201 819f385b 2019-05-10 stsp
202 8ba6ba2d 2019-05-14 stsp function test_commit_added_subdirs {
203 8ba6ba2d 2019-05-14 stsp local testroot=`test_init commit_added_subdirs`
204 8ba6ba2d 2019-05-14 stsp
205 8ba6ba2d 2019-05-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
206 8ba6ba2d 2019-05-14 stsp ret="$?"
207 8ba6ba2d 2019-05-14 stsp if [ "$ret" != "0" ]; then
208 8ba6ba2d 2019-05-14 stsp test_done "$testroot" "$ret"
209 8ba6ba2d 2019-05-14 stsp return 1
210 8ba6ba2d 2019-05-14 stsp fi
211 8ba6ba2d 2019-05-14 stsp
212 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d
213 8ba6ba2d 2019-05-14 stsp echo "new file" > $testroot/wt/d/new
214 8ba6ba2d 2019-05-14 stsp echo "new file 2" > $testroot/wt/d/new2
215 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d/f
216 8ba6ba2d 2019-05-14 stsp echo "new file 3" > $testroot/wt/d/f/new3
217 8ba6ba2d 2019-05-14 stsp mkdir -p $testroot/wt/d/f/g
218 8ba6ba2d 2019-05-14 stsp echo "new file 4" > $testroot/wt/d/f/g/new4
219 8ba6ba2d 2019-05-14 stsp
220 8ba6ba2d 2019-05-14 stsp (cd $testroot/wt && got add $testroot/wt/*/new* \
221 8ba6ba2d 2019-05-14 stsp $testroot/wt/*/*/new* $testroot/wt/*/*/*/new* > /dev/null)
222 8ba6ba2d 2019-05-14 stsp
223 8ba6ba2d 2019-05-14 stsp (cd $testroot/wt && got commit -m 'test commit_added_subdirs' \
224 8ba6ba2d 2019-05-14 stsp > $testroot/stdout 2> $testroot/stderr)
225 8ba6ba2d 2019-05-14 stsp
226 8ba6ba2d 2019-05-14 stsp local head_rev=`git_show_head $testroot/repo`
227 a3df2849 2019-05-20 stsp echo "A d/f/g/new4" > $testroot/stdout.expected
228 a3df2849 2019-05-20 stsp echo "A d/f/new3" >> $testroot/stdout.expected
229 8ba6ba2d 2019-05-14 stsp echo "A d/new" >> $testroot/stdout.expected
230 8ba6ba2d 2019-05-14 stsp echo "A d/new2" >> $testroot/stdout.expected
231 ba580f68 2020-03-22 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
232 ba580f68 2020-03-22 stsp
233 ba580f68 2020-03-22 stsp cmp -s $testroot/stdout.expected $testroot/stdout
234 ba580f68 2020-03-22 stsp ret="$?"
235 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
236 ba580f68 2020-03-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
237 ba580f68 2020-03-22 stsp fi
238 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
239 ba580f68 2020-03-22 stsp }
240 ba580f68 2020-03-22 stsp
241 ba580f68 2020-03-22 stsp function test_commit_deleted_subdirs {
242 ba580f68 2020-03-22 stsp local testroot=`test_init commit_deleted_subdirs`
243 ba580f68 2020-03-22 stsp
244 ba580f68 2020-03-22 stsp got checkout $testroot/repo $testroot/wt > /dev/null
245 ba580f68 2020-03-22 stsp ret="$?"
246 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
247 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
248 ba580f68 2020-03-22 stsp return 1
249 ba580f68 2020-03-22 stsp fi
250 ba580f68 2020-03-22 stsp
251 ba580f68 2020-03-22 stsp (cd $testroot/wt && got rm -R $testroot/wt/{epsilon,gamma} >/dev/null)
252 ba580f68 2020-03-22 stsp
253 ba580f68 2020-03-22 stsp (cd $testroot/wt && got commit -m 'test commit_deleted_subdirs' \
254 ba580f68 2020-03-22 stsp > $testroot/stdout 2> $testroot/stderr)
255 ba580f68 2020-03-22 stsp
256 ba580f68 2020-03-22 stsp local head_rev=`git_show_head $testroot/repo`
257 ba580f68 2020-03-22 stsp echo "D epsilon/zeta" > $testroot/stdout.expected
258 ba580f68 2020-03-22 stsp echo "D gamma/delta" >> $testroot/stdout.expected
259 a7648d7a 2019-06-02 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
260 ba580f68 2020-03-22 stsp
261 ba580f68 2020-03-22 stsp cmp -s $testroot/stdout.expected $testroot/stdout
262 ba580f68 2020-03-22 stsp ret="$?"
263 ba580f68 2020-03-22 stsp if [ "$ret" != "0" ]; then
264 ba580f68 2020-03-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
265 ba580f68 2020-03-22 stsp test_done "$testroot" "$ret"
266 ba580f68 2020-03-22 stsp return 1
267 ba580f68 2020-03-22 stsp fi
268 8ba6ba2d 2019-05-14 stsp
269 ba580f68 2020-03-22 stsp got tree -r $testroot/repo > $testroot/stdout
270 ba580f68 2020-03-22 stsp
271 ba580f68 2020-03-22 stsp echo "alpha" > $testroot/stdout.expected
272 ba580f68 2020-03-22 stsp echo "beta" >> $testroot/stdout.expected
273 ba580f68 2020-03-22 stsp
274 8ba6ba2d 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
275 8ba6ba2d 2019-05-14 stsp ret="$?"
276 8ba6ba2d 2019-05-14 stsp if [ "$ret" != "0" ]; then
277 a3df2849 2019-05-20 stsp diff -u $testroot/stdout.expected $testroot/stdout
278 8ba6ba2d 2019-05-14 stsp fi
279 8ba6ba2d 2019-05-14 stsp test_done "$testroot" "$ret"
280 8ba6ba2d 2019-05-14 stsp }
281 8ba6ba2d 2019-05-14 stsp
282 f363d663 2019-05-23 stsp function test_commit_rejects_conflicted_file {
283 461aee03 2019-06-29 stsp local testroot=`test_init commit_rejects_conflicted_file`
284 f363d663 2019-05-23 stsp
285 f363d663 2019-05-23 stsp local initial_rev=`git_show_head $testroot/repo`
286 f363d663 2019-05-23 stsp
287 f363d663 2019-05-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
288 f363d663 2019-05-23 stsp ret="$?"
289 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
290 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
291 f363d663 2019-05-23 stsp return 1
292 f363d663 2019-05-23 stsp fi
293 f363d663 2019-05-23 stsp
294 f363d663 2019-05-23 stsp echo "modified alpha" > $testroot/wt/alpha
295 f363d663 2019-05-23 stsp (cd $testroot/wt && got commit -m "modified alpha" >/dev/null)
296 f363d663 2019-05-23 stsp
297 f363d663 2019-05-23 stsp (cd $testroot/wt && got update -c $initial_rev > /dev/null)
298 f363d663 2019-05-23 stsp
299 f363d663 2019-05-23 stsp echo "modified alpha, too" > $testroot/wt/alpha
300 f363d663 2019-05-23 stsp
301 f363d663 2019-05-23 stsp echo "C alpha" > $testroot/stdout.expected
302 f363d663 2019-05-23 stsp echo -n "Updated to commit " >> $testroot/stdout.expected
303 f363d663 2019-05-23 stsp git_show_head $testroot/repo >> $testroot/stdout.expected
304 f363d663 2019-05-23 stsp echo >> $testroot/stdout.expected
305 9627c110 2020-04-18 stsp echo "Files with new merge conflicts: 1" >> $testroot/stdout.expected
306 f363d663 2019-05-23 stsp
307 f363d663 2019-05-23 stsp (cd $testroot/wt && got update > $testroot/stdout)
308 f363d663 2019-05-23 stsp
309 f363d663 2019-05-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
310 f363d663 2019-05-23 stsp ret="$?"
311 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
312 f363d663 2019-05-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
313 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
314 f363d663 2019-05-23 stsp return 1
315 f363d663 2019-05-23 stsp fi
316 f363d663 2019-05-23 stsp
317 f363d663 2019-05-23 stsp (cd $testroot/wt && got commit -m 'commit it' > $testroot/stdout \
318 f363d663 2019-05-23 stsp 2> $testroot/stderr)
319 f363d663 2019-05-23 stsp
320 f363d663 2019-05-23 stsp echo -n > $testroot/stdout.expected
321 f363d663 2019-05-23 stsp echo "got: cannot commit file in conflicted status" \
322 f363d663 2019-05-23 stsp > $testroot/stderr.expected
323 f363d663 2019-05-23 stsp
324 f363d663 2019-05-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
325 f363d663 2019-05-23 stsp ret="$?"
326 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
327 f363d663 2019-05-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
328 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
329 f363d663 2019-05-23 stsp return 1
330 f363d663 2019-05-23 stsp fi
331 f363d663 2019-05-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
332 f363d663 2019-05-23 stsp ret="$?"
333 f363d663 2019-05-23 stsp if [ "$ret" != "0" ]; then
334 f363d663 2019-05-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
335 f363d663 2019-05-23 stsp fi
336 f363d663 2019-05-23 stsp test_done "$testroot" "$ret"
337 f363d663 2019-05-23 stsp }
338 1a36436d 2019-06-10 stsp
339 1a36436d 2019-06-10 stsp function test_commit_single_file_multiple {
340 1a36436d 2019-06-10 stsp local testroot=`test_init commit_single_file_multiple`
341 f363d663 2019-05-23 stsp
342 1a36436d 2019-06-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
343 1a36436d 2019-06-10 stsp ret="$?"
344 1a36436d 2019-06-10 stsp if [ "$ret" != "0" ]; then
345 1a36436d 2019-06-10 stsp test_done "$testroot" "$ret"
346 1a36436d 2019-06-10 stsp return 1
347 1a36436d 2019-06-10 stsp fi
348 1a36436d 2019-06-10 stsp
349 1a36436d 2019-06-10 stsp for i in 1 2 3 4; do
350 1a36436d 2019-06-10 stsp echo "modified alpha" >> $testroot/wt/alpha
351 1a36436d 2019-06-10 stsp
352 1a36436d 2019-06-10 stsp (cd $testroot/wt && \
353 1a36436d 2019-06-10 stsp got commit -m "changed alpha" > $testroot/stdout)
354 1a36436d 2019-06-10 stsp
355 1a36436d 2019-06-10 stsp local head_rev=`git_show_head $testroot/repo`
356 1a36436d 2019-06-10 stsp echo "M alpha" > $testroot/stdout.expected
357 1a36436d 2019-06-10 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
358 1a36436d 2019-06-10 stsp
359 1a36436d 2019-06-10 stsp cmp -s $testroot/stdout.expected $testroot/stdout
360 1a36436d 2019-06-10 stsp ret="$?"
361 1a36436d 2019-06-10 stsp if [ "$ret" != "0" ]; then
362 1a36436d 2019-06-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
363 1a36436d 2019-06-10 stsp test_done "$testroot" "$ret"
364 1a36436d 2019-06-10 stsp return 1
365 1a36436d 2019-06-10 stsp fi
366 1a36436d 2019-06-10 stsp done
367 1a36436d 2019-06-10 stsp
368 1a36436d 2019-06-10 stsp test_done "$testroot" "0"
369 1a36436d 2019-06-10 stsp }
370 4866d084 2019-07-10 stsp
371 4866d084 2019-07-10 stsp function test_commit_added_and_modified_in_same_dir {
372 4866d084 2019-07-10 stsp local testroot=`test_init commit_added_and_modified_in_same_dir`
373 1a36436d 2019-06-10 stsp
374 4866d084 2019-07-10 stsp got checkout $testroot/repo $testroot/wt > /dev/null
375 4866d084 2019-07-10 stsp ret="$?"
376 4866d084 2019-07-10 stsp if [ "$ret" != "0" ]; then
377 4866d084 2019-07-10 stsp test_done "$testroot" "$ret"
378 4866d084 2019-07-10 stsp return 1
379 4866d084 2019-07-10 stsp fi
380 4866d084 2019-07-10 stsp
381 4866d084 2019-07-10 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
382 4866d084 2019-07-10 stsp echo "new file" > $testroot/wt/epsilon/new
383 4866d084 2019-07-10 stsp (cd $testroot/wt && got add epsilon/new >/dev/null)
384 4866d084 2019-07-10 stsp
385 4866d084 2019-07-10 stsp (cd $testroot/wt && got commit \
386 4866d084 2019-07-10 stsp -m 'added and modified in same dir' > $testroot/stdout \
387 4866d084 2019-07-10 stsp 2> $testroot/stderr)
388 4866d084 2019-07-10 stsp
389 4866d084 2019-07-10 stsp local head_rev=`git_show_head $testroot/repo`
390 4866d084 2019-07-10 stsp echo "A epsilon/new" > $testroot/stdout.expected
391 4866d084 2019-07-10 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
392 4866d084 2019-07-10 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
393 e0233cea 2019-07-25 stsp
394 e0233cea 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
395 e0233cea 2019-07-25 stsp ret="$?"
396 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
397 e0233cea 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
398 e0233cea 2019-07-25 stsp fi
399 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
400 e0233cea 2019-07-25 stsp }
401 e0233cea 2019-07-25 stsp
402 e0233cea 2019-07-25 stsp function test_commit_path_prefix {
403 e0233cea 2019-07-25 stsp local testroot=`test_init commit_path_prefix`
404 e0233cea 2019-07-25 stsp local commit1=`git_show_head $testroot/repo`
405 e0233cea 2019-07-25 stsp
406 e0233cea 2019-07-25 stsp got checkout -p gamma $testroot/repo $testroot/wt > /dev/null
407 e0233cea 2019-07-25 stsp ret="$?"
408 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
409 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
410 e0233cea 2019-07-25 stsp return 1
411 e0233cea 2019-07-25 stsp fi
412 e0233cea 2019-07-25 stsp
413 e0233cea 2019-07-25 stsp echo "modified delta" > $testroot/wt/delta
414 e0233cea 2019-07-25 stsp
415 e0233cea 2019-07-25 stsp (cd $testroot/wt && got commit -m 'changed gamma/delta' > $testroot/stdout)
416 e0233cea 2019-07-25 stsp
417 e0233cea 2019-07-25 stsp local commit2=`git_show_head $testroot/repo`
418 e0233cea 2019-07-25 stsp echo "M delta" > $testroot/stdout.expected
419 e0233cea 2019-07-25 stsp echo "Created commit $commit2" >> $testroot/stdout.expected
420 4866d084 2019-07-10 stsp
421 4866d084 2019-07-10 stsp cmp -s $testroot/stdout.expected $testroot/stdout
422 4866d084 2019-07-10 stsp ret="$?"
423 4866d084 2019-07-10 stsp if [ "$ret" != "0" ]; then
424 2b496619 2019-07-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
425 e0233cea 2019-07-25 stsp test_done "$testroot" "$ret"
426 e0233cea 2019-07-25 stsp return 1
427 4866d084 2019-07-10 stsp fi
428 e0233cea 2019-07-25 stsp
429 e0233cea 2019-07-25 stsp echo "diff $commit1 $commit2" > $testroot/stdout.expected
430 e0233cea 2019-07-25 stsp echo -n 'blob - ' >> $testroot/stdout.expected
431 e0233cea 2019-07-25 stsp got tree -r $testroot/repo -c $commit1 -i gamma | grep 'delta$' \
432 e0233cea 2019-07-25 stsp | cut -d' ' -f 1 >> $testroot/stdout.expected
433 e0233cea 2019-07-25 stsp echo -n 'blob + ' >> $testroot/stdout.expected
434 e0233cea 2019-07-25 stsp got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' | \
435 e0233cea 2019-07-25 stsp cut -d' ' -f 1 >> $testroot/stdout.expected
436 e0233cea 2019-07-25 stsp echo '--- gamma/delta' >> $testroot/stdout.expected
437 e0233cea 2019-07-25 stsp echo '+++ gamma/delta' >> $testroot/stdout.expected
438 e0233cea 2019-07-25 stsp echo '@@ -1 +1 @@' >> $testroot/stdout.expected
439 e0233cea 2019-07-25 stsp echo '-delta' >> $testroot/stdout.expected
440 e0233cea 2019-07-25 stsp echo '+modified delta' >> $testroot/stdout.expected
441 e0233cea 2019-07-25 stsp
442 e0233cea 2019-07-25 stsp got diff -r $testroot/repo $commit1 $commit2 > $testroot/stdout
443 f2b0a8b0 2020-07-31 stsp cmp -s $testroot/stdout.expected $testroot/stdout
444 f2b0a8b0 2020-07-31 stsp ret="$?"
445 f2b0a8b0 2020-07-31 stsp if [ "$ret" != "0" ]; then
446 f2b0a8b0 2020-07-31 stsp diff -u $testroot/stdout.expected $testroot/stdout
447 f2b0a8b0 2020-07-31 stsp test_done "$testroot" "$ret"
448 f2b0a8b0 2020-07-31 stsp return 1
449 f2b0a8b0 2020-07-31 stsp fi
450 f2b0a8b0 2020-07-31 stsp
451 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got rm delta > /dev/null)
452 f2b0a8b0 2020-07-31 stsp echo new > $testroot/wt/new
453 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got add new > /dev/null)
454 f2b0a8b0 2020-07-31 stsp
455 f2b0a8b0 2020-07-31 stsp (cd $testroot/wt && got commit -m 'remove gamma/delta; add gamma/new' \
456 f2b0a8b0 2020-07-31 stsp > $testroot/stdout)
457 f2b0a8b0 2020-07-31 stsp
458 f2b0a8b0 2020-07-31 stsp local commit3=`git_show_head $testroot/repo`
459 f2b0a8b0 2020-07-31 stsp echo "A new" > $testroot/stdout.expected
460 f2b0a8b0 2020-07-31 stsp echo "D delta" >> $testroot/stdout.expected
461 f2b0a8b0 2020-07-31 stsp echo "Created commit $commit3" >> $testroot/stdout.expected
462 f2b0a8b0 2020-07-31 stsp
463 f2b0a8b0 2020-07-31 stsp cmp -s $testroot/stdout.expected $testroot/stdout
464 f2b0a8b0 2020-07-31 stsp ret="$?"
465 f2b0a8b0 2020-07-31 stsp if [ "$ret" != "0" ]; then
466 f2b0a8b0 2020-07-31 stsp diff -u $testroot/stdout.expected $testroot/stdout
467 f2b0a8b0 2020-07-31 stsp test_done "$testroot" "$ret"
468 f2b0a8b0 2020-07-31 stsp return 1
469 f2b0a8b0 2020-07-31 stsp fi
470 f2b0a8b0 2020-07-31 stsp
471 f2b0a8b0 2020-07-31 stsp echo "diff $commit2 $commit3" > $testroot/stdout.expected
472 f2b0a8b0 2020-07-31 stsp echo -n 'blob - ' >> $testroot/stdout.expected
473 f2b0a8b0 2020-07-31 stsp got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' \
474 f2b0a8b0 2020-07-31 stsp | cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
475 f2b0a8b0 2020-07-31 stsp >> $testroot/stdout.expected
476 f2b0a8b0 2020-07-31 stsp echo 'blob + /dev/null' >> $testroot/stdout.expected
477 f2b0a8b0 2020-07-31 stsp echo '--- gamma/delta' >> $testroot/stdout.expected
478 f2b0a8b0 2020-07-31 stsp echo '+++ /dev/null' >> $testroot/stdout.expected
479 f2b0a8b0 2020-07-31 stsp echo '@@ -1 +0,0 @@' >> $testroot/stdout.expected
480 f2b0a8b0 2020-07-31 stsp echo '-modified delta' >> $testroot/stdout.expected
481 f2b0a8b0 2020-07-31 stsp echo 'blob - /dev/null' >> $testroot/stdout.expected
482 f2b0a8b0 2020-07-31 stsp echo -n 'blob + ' >> $testroot/stdout.expected
483 f2b0a8b0 2020-07-31 stsp got tree -r $testroot/repo -c $commit3 -i gamma | grep 'new$' | \
484 f2b0a8b0 2020-07-31 stsp cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
485 f2b0a8b0 2020-07-31 stsp >> $testroot/stdout.expected
486 f2b0a8b0 2020-07-31 stsp echo '--- /dev/null' >> $testroot/stdout.expected
487 f2b0a8b0 2020-07-31 stsp echo '+++ gamma/new' >> $testroot/stdout.expected
488 f2b0a8b0 2020-07-31 stsp echo '@@ -0,0 +1 @@' >> $testroot/stdout.expected
489 f2b0a8b0 2020-07-31 stsp echo '+new' >> $testroot/stdout.expected
490 f2b0a8b0 2020-07-31 stsp
491 f2b0a8b0 2020-07-31 stsp got diff -r $testroot/repo $commit2 $commit3 > $testroot/stdout
492 e0233cea 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
493 e0233cea 2019-07-25 stsp ret="$?"
494 e0233cea 2019-07-25 stsp if [ "$ret" != "0" ]; then
495 e0233cea 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
496 e0233cea 2019-07-25 stsp fi
497 4866d084 2019-07-10 stsp test_done "$testroot" "$ret"
498 f2b0a8b0 2020-07-31 stsp return "$ret"
499 4866d084 2019-07-10 stsp }
500 90e8619e 2019-07-25 stsp
501 90e8619e 2019-07-25 stsp function test_commit_dir_path {
502 90e8619e 2019-07-25 stsp local testroot=`test_init commit_dir_path`
503 4866d084 2019-07-10 stsp
504 90e8619e 2019-07-25 stsp got checkout $testroot/repo $testroot/wt > /dev/null
505 90e8619e 2019-07-25 stsp ret="$?"
506 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
507 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
508 90e8619e 2019-07-25 stsp return 1
509 90e8619e 2019-07-25 stsp fi
510 90e8619e 2019-07-25 stsp
511 90e8619e 2019-07-25 stsp echo "modified alpha" > $testroot/wt/alpha
512 90e8619e 2019-07-25 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
513 90e8619e 2019-07-25 stsp
514 90e8619e 2019-07-25 stsp (cd $testroot/wt && got commit -m 'changed zeta' epsilon \
515 90e8619e 2019-07-25 stsp > $testroot/stdout)
516 90e8619e 2019-07-25 stsp
517 90e8619e 2019-07-25 stsp local head_rev=`git_show_head $testroot/repo`
518 90e8619e 2019-07-25 stsp echo "M epsilon/zeta" >> $testroot/stdout.expected
519 90e8619e 2019-07-25 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
520 90e8619e 2019-07-25 stsp
521 90e8619e 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
522 90e8619e 2019-07-25 stsp ret="$?"
523 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
524 90e8619e 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
525 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
526 90e8619e 2019-07-25 stsp return 1
527 90e8619e 2019-07-25 stsp fi
528 90e8619e 2019-07-25 stsp
529 90e8619e 2019-07-25 stsp echo "M alpha" > $testroot/stdout.expected
530 90e8619e 2019-07-25 stsp (cd $testroot/wt && got status > $testroot/stdout)
531 90e8619e 2019-07-25 stsp cmp -s $testroot/stdout.expected $testroot/stdout
532 90e8619e 2019-07-25 stsp ret="$?"
533 90e8619e 2019-07-25 stsp if [ "$ret" != "0" ]; then
534 90e8619e 2019-07-25 stsp diff -u $testroot/stdout.expected $testroot/stdout
535 90e8619e 2019-07-25 stsp fi
536 90e8619e 2019-07-25 stsp test_done "$testroot" "$ret"
537 90e8619e 2019-07-25 stsp }
538 5c1e53bc 2019-07-28 stsp
539 5c1e53bc 2019-07-28 stsp function test_commit_selected_paths {
540 5c1e53bc 2019-07-28 stsp local testroot=`test_init commit_selected_paths`
541 5c1e53bc 2019-07-28 stsp
542 5c1e53bc 2019-07-28 stsp got checkout $testroot/repo $testroot/wt > /dev/null
543 5c1e53bc 2019-07-28 stsp ret="$?"
544 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
545 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
546 5c1e53bc 2019-07-28 stsp return 1
547 5c1e53bc 2019-07-28 stsp fi
548 5c1e53bc 2019-07-28 stsp
549 5c1e53bc 2019-07-28 stsp echo "modified alpha" > $testroot/wt/alpha
550 5c1e53bc 2019-07-28 stsp echo "modified delta" > $testroot/wt/gamma/delta
551 5c1e53bc 2019-07-28 stsp echo "modified zeta" > $testroot/wt/epsilon/zeta
552 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got rm beta >/dev/null)
553 5c1e53bc 2019-07-28 stsp echo "new file" > $testroot/wt/new
554 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got add new >/dev/null)
555 90e8619e 2019-07-25 stsp
556 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got commit -m 'many paths' nonexistent alpha \
557 5c1e53bc 2019-07-28 stsp > $testroot/stdout 2> $testroot/stderr)
558 5c1e53bc 2019-07-28 stsp ret="$?"
559 5c1e53bc 2019-07-28 stsp if [ "$ret" == "0" ]; then
560 5c1e53bc 2019-07-28 stsp echo "commit succeeded unexpectedly" >&2
561 5c1e53bc 2019-07-28 stsp test_done "$testroot" "1"
562 5c1e53bc 2019-07-28 stsp return 1
563 5c1e53bc 2019-07-28 stsp fi
564 5c1e53bc 2019-07-28 stsp echo "got: nonexistent: bad path" > $testroot/stderr.expected
565 5c1e53bc 2019-07-28 stsp
566 5c1e53bc 2019-07-28 stsp cmp -s $testroot/stderr.expected $testroot/stderr
567 5c1e53bc 2019-07-28 stsp ret="$?"
568 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
569 5c1e53bc 2019-07-28 stsp diff -u $testroot/stderr.expected $testroot/stderr
570 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
571 5c1e53bc 2019-07-28 stsp return 1
572 5c1e53bc 2019-07-28 stsp fi
573 5c1e53bc 2019-07-28 stsp
574 5c1e53bc 2019-07-28 stsp (cd $testroot/wt && got commit -m 'many paths' \
575 5c1e53bc 2019-07-28 stsp beta new gamma > $testroot/stdout)
576 5c1e53bc 2019-07-28 stsp
577 5c1e53bc 2019-07-28 stsp local head_rev=`git_show_head $testroot/repo`
578 5c1e53bc 2019-07-28 stsp echo "A new" > $testroot/stdout.expected
579 5c1e53bc 2019-07-28 stsp echo "D beta" >> $testroot/stdout.expected
580 5c1e53bc 2019-07-28 stsp echo "M gamma/delta" >> $testroot/stdout.expected
581 5c1e53bc 2019-07-28 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
582 5c1e53bc 2019-07-28 stsp
583 5c1e53bc 2019-07-28 stsp cmp -s $testroot/stdout.expected $testroot/stdout
584 5c1e53bc 2019-07-28 stsp ret="$?"
585 5c1e53bc 2019-07-28 stsp if [ "$ret" != "0" ]; then
586 5c1e53bc 2019-07-28 stsp diff -u $testroot/stdout.expected $testroot/stdout
587 5c1e53bc 2019-07-28 stsp fi
588 5c1e53bc 2019-07-28 stsp test_done "$testroot" "$ret"
589 5c1e53bc 2019-07-28 stsp }
590 5c1e53bc 2019-07-28 stsp
591 916f288c 2019-07-30 stsp function test_commit_outside_refs_heads {
592 916f288c 2019-07-30 stsp local testroot=`test_init commit_outside_refs_heads`
593 916f288c 2019-07-30 stsp
594 e31abbf2 2020-03-22 stsp got ref -r $testroot/repo -c master refs/remotes/origin/master
595 916f288c 2019-07-30 stsp
596 916f288c 2019-07-30 stsp got checkout -b refs/remotes/origin/master \
597 916f288c 2019-07-30 stsp $testroot/repo $testroot/wt > /dev/null
598 916f288c 2019-07-30 stsp ret="$?"
599 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
600 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
601 916f288c 2019-07-30 stsp return 1
602 916f288c 2019-07-30 stsp fi
603 916f288c 2019-07-30 stsp
604 916f288c 2019-07-30 stsp echo "modified alpha" > $testroot/wt/alpha
605 916f288c 2019-07-30 stsp
606 916f288c 2019-07-30 stsp (cd $testroot/wt && got commit -m 'change alpha' \
607 916f288c 2019-07-30 stsp > $testroot/stdout 2> $testroot/stderr)
608 916f288c 2019-07-30 stsp ret="$?"
609 916f288c 2019-07-30 stsp if [ "$ret" == "0" ]; then
610 916f288c 2019-07-30 stsp echo "commit succeeded unexpectedly" >&2
611 916f288c 2019-07-30 stsp test_done "$testroot" "1"
612 916f288c 2019-07-30 stsp return 1
613 916f288c 2019-07-30 stsp fi
614 916f288c 2019-07-30 stsp
615 916f288c 2019-07-30 stsp echo -n > $testroot/stdout.expected
616 916f288c 2019-07-30 stsp cmp -s $testroot/stdout.expected $testroot/stdout
617 916f288c 2019-07-30 stsp ret="$?"
618 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
619 916f288c 2019-07-30 stsp diff -u $testroot/stdout.expected $testroot/stdout
620 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
621 916f288c 2019-07-30 stsp return 1
622 916f288c 2019-07-30 stsp fi
623 916f288c 2019-07-30 stsp
624 916f288c 2019-07-30 stsp echo -n "got: will not commit to a branch outside the " \
625 916f288c 2019-07-30 stsp > $testroot/stderr.expected
626 916f288c 2019-07-30 stsp echo '"refs/heads/" reference namespace' \
627 916f288c 2019-07-30 stsp >> $testroot/stderr.expected
628 916f288c 2019-07-30 stsp cmp -s $testroot/stderr.expected $testroot/stderr
629 916f288c 2019-07-30 stsp ret="$?"
630 916f288c 2019-07-30 stsp if [ "$ret" != "0" ]; then
631 916f288c 2019-07-30 stsp diff -u $testroot/stderr.expected $testroot/stderr
632 916f288c 2019-07-30 stsp fi
633 916f288c 2019-07-30 stsp test_done "$testroot" "$ret"
634 916f288c 2019-07-30 stsp }
635 916f288c 2019-07-30 stsp
636 84792843 2019-08-09 stsp function test_commit_no_email {
637 84792843 2019-08-09 stsp local testroot=`test_init commit_no_email`
638 916f288c 2019-07-30 stsp
639 84792843 2019-08-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
640 84792843 2019-08-09 stsp ret="$?"
641 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
642 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
643 84792843 2019-08-09 stsp return 1
644 84792843 2019-08-09 stsp fi
645 84792843 2019-08-09 stsp
646 84792843 2019-08-09 stsp echo "modified alpha" > $testroot/wt/alpha
647 84792843 2019-08-09 stsp (cd $testroot/wt && env GOT_AUTHOR=":flan_hacker:" \
648 84792843 2019-08-09 stsp got commit -m 'test no email' > $testroot/stdout \
649 84792843 2019-08-09 stsp 2> $testroot/stderr)
650 84792843 2019-08-09 stsp
651 84792843 2019-08-09 stsp echo -n "got: GOT_AUTHOR environment variable contains no email " \
652 84792843 2019-08-09 stsp > $testroot/stderr.expected
653 84792843 2019-08-09 stsp echo -n "address; an email address is required for compatibility "\
654 84792843 2019-08-09 stsp >> $testroot/stderr.expected
655 84792843 2019-08-09 stsp echo "with Git" >> $testroot/stderr.expected
656 84792843 2019-08-09 stsp cmp -s $testroot/stderr.expected $testroot/stderr
657 84792843 2019-08-09 stsp ret="$?"
658 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
659 84792843 2019-08-09 stsp diff -u $testroot/stderr.expected $testroot/stderr
660 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
661 84792843 2019-08-09 stsp return 1
662 84792843 2019-08-09 stsp fi
663 84792843 2019-08-09 stsp
664 84792843 2019-08-09 stsp echo -n > $testroot/stdout.expected
665 84792843 2019-08-09 stsp cmp -s $testroot/stdout.expected $testroot/stdout
666 84792843 2019-08-09 stsp ret="$?"
667 84792843 2019-08-09 stsp if [ "$ret" != "0" ]; then
668 84792843 2019-08-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
669 84792843 2019-08-09 stsp fi
670 84792843 2019-08-09 stsp test_done "$testroot" "$ret"
671 84792843 2019-08-09 stsp }
672 6af1ccbd 2019-08-16 stsp
673 6af1ccbd 2019-08-16 stsp function test_commit_tree_entry_sorting {
674 6af1ccbd 2019-08-16 stsp local testroot=`test_init commit_tree_entry_sorting`
675 6af1ccbd 2019-08-16 stsp
676 6af1ccbd 2019-08-16 stsp got checkout $testroot/repo $testroot/wt > /dev/null
677 6af1ccbd 2019-08-16 stsp ret="$?"
678 6af1ccbd 2019-08-16 stsp if [ "$ret" != "0" ]; then
679 6af1ccbd 2019-08-16 stsp test_done "$testroot" "$ret"
680 6af1ccbd 2019-08-16 stsp return 1
681 6af1ccbd 2019-08-16 stsp fi
682 6af1ccbd 2019-08-16 stsp
683 6af1ccbd 2019-08-16 stsp # Git's index gets corrupted when tree entries are written in the
684 6af1ccbd 2019-08-16 stsp # order defined by got_path_cmp() rather than Git's own ordering.
685 6af1ccbd 2019-08-16 stsp # Create a new tree where a directory "got" and a file "got-version"
686 6af1ccbd 2019-08-16 stsp # would sort in the wrong order according to Git's opinion.
687 6af1ccbd 2019-08-16 stsp mkdir $testroot/wt/got
688 6af1ccbd 2019-08-16 stsp touch $testroot/wt/got/foo
689 6af1ccbd 2019-08-16 stsp echo foo > $testroot/wt/got-version
690 6af1ccbd 2019-08-16 stsp echo zzz > $testroot/wt/zzz
691 6af1ccbd 2019-08-16 stsp (cd $testroot/wt && got add got-version got/foo zzz > /dev/null)
692 84792843 2019-08-09 stsp
693 6af1ccbd 2019-08-16 stsp (cd $testroot/wt && got commit -m 'test' > /dev/null)
694 84792843 2019-08-09 stsp
695 6af1ccbd 2019-08-16 stsp # Let git-fsck verify the newly written tree to make sure Git is happy
696 6af1ccbd 2019-08-16 stsp (cd $testroot/repo && git fsck --strict \
697 6af1ccbd 2019-08-16 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
698 257add31 2020-09-09 stsp ret="$?"
699 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
700 257add31 2020-09-09 stsp }
701 257add31 2020-09-09 stsp
702 257add31 2020-09-09 stsp function test_commit_gotconfig_author {
703 257add31 2020-09-09 stsp local testroot=`test_init commit_gotconfig_author`
704 257add31 2020-09-09 stsp
705 257add31 2020-09-09 stsp got checkout $testroot/repo $testroot/wt > /dev/null
706 257add31 2020-09-09 stsp ret="$?"
707 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
708 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
709 257add31 2020-09-09 stsp return 1
710 257add31 2020-09-09 stsp fi
711 257add31 2020-09-09 stsp echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
712 257add31 2020-09-09 stsp > $testroot/repo/.git/got.conf
713 257add31 2020-09-09 stsp
714 257add31 2020-09-09 stsp echo "modified alpha" > $testroot/wt/alpha
715 257add31 2020-09-09 stsp (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
716 257add31 2020-09-09 stsp ret="$?"
717 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
718 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
719 257add31 2020-09-09 stsp return 1
720 257add31 2020-09-09 stsp fi
721 257add31 2020-09-09 stsp
722 257add31 2020-09-09 stsp (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
723 257add31 2020-09-09 stsp ret="$?"
724 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
725 257add31 2020-09-09 stsp test_done "$testroot" "$ret"
726 257add31 2020-09-09 stsp return 1
727 257add31 2020-09-09 stsp fi
728 257add31 2020-09-09 stsp
729 257add31 2020-09-09 stsp echo "from: Flan Luck <flan_luck@openbsd.org>" \
730 257add31 2020-09-09 stsp > $testroot/stdout.expected
731 257add31 2020-09-09 stsp cmp -s $testroot/stdout.expected $testroot/stdout
732 6af1ccbd 2019-08-16 stsp ret="$?"
733 257add31 2020-09-09 stsp if [ "$ret" != "0" ]; then
734 257add31 2020-09-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
735 257add31 2020-09-09 stsp fi
736 6af1ccbd 2019-08-16 stsp test_done "$testroot" "$ret"
737 6af1ccbd 2019-08-16 stsp }
738 aba9c984 2019-09-08 stsp
739 aba9c984 2019-09-08 stsp function test_commit_gitconfig_author {
740 aba9c984 2019-09-08 stsp local testroot=`test_init commit_gitconfig_author`
741 84792843 2019-08-09 stsp
742 aba9c984 2019-09-08 stsp got checkout $testroot/repo $testroot/wt > /dev/null
743 aba9c984 2019-09-08 stsp ret="$?"
744 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
745 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
746 aba9c984 2019-09-08 stsp return 1
747 aba9c984 2019-09-08 stsp fi
748 aba9c984 2019-09-08 stsp
749 aba9c984 2019-09-08 stsp (cd $testroot/repo && git config user.name 'Flan Luck')
750 aba9c984 2019-09-08 stsp (cd $testroot/repo && git config user.email 'flan_luck@openbsd.org')
751 aba9c984 2019-09-08 stsp
752 aba9c984 2019-09-08 stsp echo "modified alpha" > $testroot/wt/alpha
753 aba9c984 2019-09-08 stsp (cd $testroot/wt && got commit -m 'test gitconfig author' > /dev/null)
754 aba9c984 2019-09-08 stsp ret="$?"
755 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
756 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
757 aba9c984 2019-09-08 stsp return 1
758 aba9c984 2019-09-08 stsp fi
759 aba9c984 2019-09-08 stsp
760 aba9c984 2019-09-08 stsp (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
761 aba9c984 2019-09-08 stsp ret="$?"
762 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
763 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
764 aba9c984 2019-09-08 stsp return 1
765 aba9c984 2019-09-08 stsp fi
766 aba9c984 2019-09-08 stsp
767 aba9c984 2019-09-08 stsp echo "from: Flan Luck <flan_luck@openbsd.org>" \
768 aba9c984 2019-09-08 stsp > $testroot/stdout.expected
769 aba9c984 2019-09-08 stsp cmp -s $testroot/stdout.expected $testroot/stdout
770 aba9c984 2019-09-08 stsp ret="$?"
771 aba9c984 2019-09-08 stsp if [ "$ret" != "0" ]; then
772 aba9c984 2019-09-08 stsp diff -u $testroot/stdout.expected $testroot/stdout
773 aba9c984 2019-09-08 stsp fi
774 aba9c984 2019-09-08 stsp test_done "$testroot" "$ret"
775 aba9c984 2019-09-08 stsp }
776 1ebedb77 2019-10-19 stsp
777 1ebedb77 2019-10-19 stsp function test_commit_xbit_change {
778 1ebedb77 2019-10-19 stsp local testroot=`test_init commit_xbit_change`
779 1ebedb77 2019-10-19 stsp
780 1ebedb77 2019-10-19 stsp got checkout $testroot/repo $testroot/wt > /dev/null
781 1ebedb77 2019-10-19 stsp ret="$?"
782 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
783 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
784 1ebedb77 2019-10-19 stsp return 1
785 1ebedb77 2019-10-19 stsp fi
786 1ebedb77 2019-10-19 stsp
787 1ebedb77 2019-10-19 stsp chmod +x $testroot/wt/alpha
788 1ebedb77 2019-10-19 stsp
789 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
790 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
791 aba9c984 2019-09-08 stsp
792 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
793 1ebedb77 2019-10-19 stsp ret="$?"
794 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
795 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
796 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
797 1ebedb77 2019-10-19 stsp return 1
798 1ebedb77 2019-10-19 stsp fi
799 1ebedb77 2019-10-19 stsp
800 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got commit -mx > $testroot/stdout)
801 1ebedb77 2019-10-19 stsp ret="$?"
802 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
803 1ebedb77 2019-10-19 stsp echo "got commit failed unexpectedly"
804 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
805 1ebedb77 2019-10-19 stsp return 1
806 1ebedb77 2019-10-19 stsp fi
807 1ebedb77 2019-10-19 stsp
808 1ebedb77 2019-10-19 stsp local commit_id=`git_show_head $testroot/repo`
809 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
810 1ebedb77 2019-10-19 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
811 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
812 1ebedb77 2019-10-19 stsp ret="$?"
813 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
814 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
815 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
816 1ebedb77 2019-10-19 stsp return 1
817 1ebedb77 2019-10-19 stsp fi
818 1ebedb77 2019-10-19 stsp
819 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
820 1ebedb77 2019-10-19 stsp
821 1ebedb77 2019-10-19 stsp echo -n > $testroot/stdout.expected
822 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
823 1ebedb77 2019-10-19 stsp ret="$?"
824 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
825 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
826 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
827 1ebedb77 2019-10-19 stsp return 1
828 1ebedb77 2019-10-19 stsp fi
829 1ebedb77 2019-10-19 stsp
830 1ebedb77 2019-10-19 stsp chmod -x $testroot/wt/alpha
831 1ebedb77 2019-10-19 stsp
832 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
833 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
834 1ebedb77 2019-10-19 stsp
835 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
836 1ebedb77 2019-10-19 stsp ret="$?"
837 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
838 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
839 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
840 1ebedb77 2019-10-19 stsp return 1
841 1ebedb77 2019-10-19 stsp fi
842 1ebedb77 2019-10-19 stsp
843 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got commit -mx > $testroot/stdout)
844 1ebedb77 2019-10-19 stsp ret="$?"
845 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
846 1ebedb77 2019-10-19 stsp echo "got commit failed unexpectedly"
847 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
848 1ebedb77 2019-10-19 stsp return 1
849 1ebedb77 2019-10-19 stsp fi
850 1ebedb77 2019-10-19 stsp
851 1ebedb77 2019-10-19 stsp local commit_id=`git_show_head $testroot/repo`
852 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
853 1ebedb77 2019-10-19 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
854 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
855 1ebedb77 2019-10-19 stsp ret="$?"
856 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
857 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
858 1ebedb77 2019-10-19 stsp test_done "$testroot" "$ret"
859 1ebedb77 2019-10-19 stsp return 1
860 1ebedb77 2019-10-19 stsp fi
861 1ebedb77 2019-10-19 stsp
862 1ebedb77 2019-10-19 stsp chmod +x $testroot/wt/alpha
863 1ebedb77 2019-10-19 stsp
864 1ebedb77 2019-10-19 stsp echo 'm alpha' > $testroot/stdout.expected
865 1ebedb77 2019-10-19 stsp (cd $testroot/wt && got status > $testroot/stdout)
866 f7b97ccb 2020-04-14 stsp
867 f7b97ccb 2020-04-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
868 f7b97ccb 2020-04-14 stsp ret="$?"
869 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
870 f7b97ccb 2020-04-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
871 f7b97ccb 2020-04-14 stsp fi
872 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
873 f7b97ccb 2020-04-14 stsp }
874 f7b97ccb 2020-04-14 stsp
875 f7b97ccb 2020-04-14 stsp function commit_check_mode {
876 f7b97ccb 2020-04-14 stsp local mode="$1"
877 f7b97ccb 2020-04-14 stsp local expected_mode="$2"
878 f7b97ccb 2020-04-14 stsp
879 f7b97ccb 2020-04-14 stsp chmod 644 $testroot/wt/alpha
880 f7b97ccb 2020-04-14 stsp echo a >> $testroot/wt/alpha
881 f7b97ccb 2020-04-14 stsp chmod $mode $testroot/wt/alpha
882 f7b97ccb 2020-04-14 stsp
883 f7b97ccb 2020-04-14 stsp (cd $testroot/wt && got commit -mm > $testroot/stdout)
884 f7b97ccb 2020-04-14 stsp ret="$?"
885 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
886 f7b97ccb 2020-04-14 stsp echo "got commit failed unexpectedly"
887 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
888 f7b97ccb 2020-04-14 stsp return 1
889 f7b97ccb 2020-04-14 stsp fi
890 1ebedb77 2019-10-19 stsp
891 f7b97ccb 2020-04-14 stsp local commit_id=`git_show_head $testroot/repo`
892 f7b97ccb 2020-04-14 stsp echo 'M alpha' > $testroot/stdout.expected
893 f7b97ccb 2020-04-14 stsp echo "Created commit $commit_id" >> $testroot/stdout.expected
894 f7b97ccb 2020-04-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
895 f7b97ccb 2020-04-14 stsp ret="$?"
896 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
897 f7b97ccb 2020-04-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
898 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
899 f7b97ccb 2020-04-14 stsp fi
900 f7b97ccb 2020-04-14 stsp
901 f7b97ccb 2020-04-14 stsp local tree_id=$(got cat -r $testroot/repo $commit_id | \
902 f7b97ccb 2020-04-14 stsp grep ^tree | cut -d' ' -f2)
903 f7b97ccb 2020-04-14 stsp local alpha_id=$(got cat -r $testroot/repo $tree_id | \
904 f7b97ccb 2020-04-14 stsp grep 'alpha$' | cut -d' ' -f1)
905 f7b97ccb 2020-04-14 stsp echo "$alpha_id $expected_mode alpha" > $testroot/stdout.expected
906 f7b97ccb 2020-04-14 stsp got cat -r $testroot/repo $tree_id | grep 'alpha$' > $testroot/stdout
907 1ebedb77 2019-10-19 stsp cmp -s $testroot/stdout.expected $testroot/stdout
908 1ebedb77 2019-10-19 stsp ret="$?"
909 1ebedb77 2019-10-19 stsp if [ "$ret" != "0" ]; then
910 1ebedb77 2019-10-19 stsp diff -u $testroot/stdout.expected $testroot/stdout
911 1ebedb77 2019-10-19 stsp fi
912 f7b97ccb 2020-04-14 stsp return $ret
913 f7b97ccb 2020-04-14 stsp }
914 f7b97ccb 2020-04-14 stsp
915 f7b97ccb 2020-04-14 stsp function test_commit_normalizes_filemodes {
916 f7b97ccb 2020-04-14 stsp local testroot=`test_init commit_normalizes_filemodes`
917 f7b97ccb 2020-04-14 stsp
918 f7b97ccb 2020-04-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
919 f7b97ccb 2020-04-14 stsp ret="$?"
920 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
921 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
922 f7b97ccb 2020-04-14 stsp return 1
923 f7b97ccb 2020-04-14 stsp fi
924 f7b97ccb 2020-04-14 stsp
925 f7b97ccb 2020-04-14 stsp modes="600 400 460 640 440 660 444 666"
926 f7b97ccb 2020-04-14 stsp for m in $modes; do
927 f7b97ccb 2020-04-14 stsp commit_check_mode "$m" "0100644"
928 cb35d58a 2020-04-14 stsp ret="$?"
929 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
930 f7b97ccb 2020-04-14 stsp break
931 f7b97ccb 2020-04-14 stsp fi
932 f7b97ccb 2020-04-14 stsp done
933 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
934 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
935 f7b97ccb 2020-04-14 stsp return 1
936 f7b97ccb 2020-04-14 stsp fi
937 f7b97ccb 2020-04-14 stsp modes="700 500 570 750 550 770 555 777"
938 f7b97ccb 2020-04-14 stsp for m in $modes; do
939 f7b97ccb 2020-04-14 stsp commit_check_mode "$m" "0100755"
940 cb35d58a 2020-04-14 stsp ret="$?"
941 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
942 f7b97ccb 2020-04-14 stsp break
943 f7b97ccb 2020-04-14 stsp fi
944 f7b97ccb 2020-04-14 stsp done
945 f7b97ccb 2020-04-14 stsp if [ "$ret" != "0" ]; then
946 f7b97ccb 2020-04-14 stsp test_done "$testroot" "$ret"
947 e7303626 2020-05-14 stsp return 1
948 e7303626 2020-05-14 stsp fi
949 e7303626 2020-05-14 stsp test_done "$testroot" "$ret"
950 e7303626 2020-05-14 stsp }
951 e7303626 2020-05-14 stsp
952 e7303626 2020-05-14 stsp function test_commit_with_unrelated_submodule {
953 e7303626 2020-05-14 stsp local testroot=`test_init commit_with_unrelated_submodule`
954 e7303626 2020-05-14 stsp
955 e7303626 2020-05-14 stsp make_single_file_repo $testroot/repo2 foo
956 e7303626 2020-05-14 stsp
957 e7303626 2020-05-14 stsp (cd $testroot/repo && git submodule -q add ../repo2)
958 e7303626 2020-05-14 stsp (cd $testroot/repo && git commit -q -m 'adding submodule')
959 e7303626 2020-05-14 stsp
960 e7303626 2020-05-14 stsp got checkout $testroot/repo $testroot/wt > /dev/null
961 e7303626 2020-05-14 stsp ret="$?"
962 e7303626 2020-05-14 stsp if [ "$ret" != "0" ]; then
963 7aadece8 2020-05-17 stsp echo "checkout failed unexpectedly" >&2
964 e7303626 2020-05-14 stsp test_done "$testroot" "$ret"
965 e7303626 2020-05-14 stsp return 1
966 e7303626 2020-05-14 stsp fi
967 e7303626 2020-05-14 stsp
968 e7303626 2020-05-14 stsp echo "modified alpha" > $testroot/wt/alpha
969 e7303626 2020-05-14 stsp
970 7aadece8 2020-05-17 stsp echo "" > $testroot/stdout.expected
971 7aadece8 2020-05-17 stsp
972 74ad335c 2020-06-23 stsp (cd $testroot/wt && got commit -m 'modify alpha' > $testroot/stdout)
973 e7303626 2020-05-14 stsp ret="$?"
974 7aadece8 2020-05-17 stsp if [ "$ret" != "0" ]; then
975 7aadece8 2020-05-17 stsp echo "commit failed unexpectedly" >&2
976 7aadece8 2020-05-17 stsp test_done "$testroot" "$ret"
977 f7b97ccb 2020-04-14 stsp return 1
978 f7b97ccb 2020-04-14 stsp fi
979 e7303626 2020-05-14 stsp
980 7aadece8 2020-05-17 stsp local head_rev=`git_show_head $testroot/repo`
981 7aadece8 2020-05-17 stsp echo "M alpha" > $testroot/stdout.expected
982 7aadece8 2020-05-17 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
983 3d9a4ec4 2020-07-23 stsp
984 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
985 3d9a4ec4 2020-07-23 stsp ret="$?"
986 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
987 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
988 3d9a4ec4 2020-07-23 stsp fi
989 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
990 3d9a4ec4 2020-07-23 stsp }
991 3d9a4ec4 2020-07-23 stsp
992 bd6aa359 2020-07-23 stsp function check_symlinks {
993 bd6aa359 2020-07-23 stsp local wtpath="$1"
994 bd6aa359 2020-07-23 stsp if ! [ -h $wtpath/alpha.link ]; then
995 bd6aa359 2020-07-23 stsp echo "alpha.link is not a symlink"
996 bd6aa359 2020-07-23 stsp return 1
997 bd6aa359 2020-07-23 stsp fi
998 3d9a4ec4 2020-07-23 stsp
999 bd6aa359 2020-07-23 stsp readlink $wtpath/alpha.link > $testroot/stdout
1000 bd6aa359 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1001 bd6aa359 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1002 3d9a4ec4 2020-07-23 stsp ret="$?"
1003 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1004 bd6aa359 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1005 3d9a4ec4 2020-07-23 stsp return 1
1006 3d9a4ec4 2020-07-23 stsp fi
1007 3d9a4ec4 2020-07-23 stsp
1008 bd6aa359 2020-07-23 stsp if ! [ -h $wtpath/epsilon.link ]; then
1009 bd6aa359 2020-07-23 stsp echo "epsilon.link is not a symlink"
1010 bd6aa359 2020-07-23 stsp return 1
1011 bd6aa359 2020-07-23 stsp fi
1012 3d9a4ec4 2020-07-23 stsp
1013 bd6aa359 2020-07-23 stsp readlink $wtpath/epsilon.link > $testroot/stdout
1014 bd6aa359 2020-07-23 stsp echo "epsilon" > $testroot/stdout.expected
1015 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1016 3d9a4ec4 2020-07-23 stsp ret="$?"
1017 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1018 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1019 3d9a4ec4 2020-07-23 stsp return 1
1020 3d9a4ec4 2020-07-23 stsp fi
1021 3d9a4ec4 2020-07-23 stsp
1022 bd6aa359 2020-07-23 stsp if [ -h $wtpath/passwd.link ]; then
1023 bd6aa359 2020-07-23 stsp echo -n "passwd.link is a symlink and points outside of work tree: " >&2
1024 bd6aa359 2020-07-23 stsp readlink $wtpath/passwd.link >&2
1025 bd6aa359 2020-07-23 stsp return 1
1026 bd6aa359 2020-07-23 stsp fi
1027 bd6aa359 2020-07-23 stsp
1028 bd6aa359 2020-07-23 stsp echo -n "/etc/passwd" > $testroot/content.expected
1029 bd6aa359 2020-07-23 stsp cp $wtpath/passwd.link $testroot/content
1030 3d9a4ec4 2020-07-23 stsp ret="$?"
1031 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1032 bd6aa359 2020-07-23 stsp echo "cp command failed unexpectedly" >&2
1033 3d9a4ec4 2020-07-23 stsp return 1
1034 3d9a4ec4 2020-07-23 stsp fi
1035 3d9a4ec4 2020-07-23 stsp
1036 bd6aa359 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
1037 bd6aa359 2020-07-23 stsp ret="$?"
1038 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1039 bd6aa359 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
1040 3d9a4ec4 2020-07-23 stsp return 1
1041 3d9a4ec4 2020-07-23 stsp fi
1042 3d9a4ec4 2020-07-23 stsp
1043 bd6aa359 2020-07-23 stsp readlink $wtpath/epsilon/beta.link > $testroot/stdout
1044 bd6aa359 2020-07-23 stsp echo "../beta" > $testroot/stdout.expected
1045 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1046 3d9a4ec4 2020-07-23 stsp ret="$?"
1047 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1048 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1049 3d9a4ec4 2020-07-23 stsp return 1
1050 3d9a4ec4 2020-07-23 stsp fi
1051 7aadece8 2020-05-17 stsp
1052 bd6aa359 2020-07-23 stsp readlink $wtpath/nonexistent.link > $testroot/stdout
1053 bd6aa359 2020-07-23 stsp echo "nonexistent" > $testroot/stdout.expected
1054 7aadece8 2020-05-17 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1055 e7303626 2020-05-14 stsp ret="$?"
1056 e7303626 2020-05-14 stsp if [ "$ret" != "0" ]; then
1057 7aadece8 2020-05-17 stsp diff -u $testroot/stdout.expected $testroot/stdout
1058 3d9a4ec4 2020-07-23 stsp return 1
1059 e7303626 2020-05-14 stsp fi
1060 3d9a4ec4 2020-07-23 stsp
1061 bd6aa359 2020-07-23 stsp return 0
1062 bd6aa359 2020-07-23 stsp }
1063 3d9a4ec4 2020-07-23 stsp
1064 bd6aa359 2020-07-23 stsp function test_commit_symlink {
1065 bd6aa359 2020-07-23 stsp local testroot=`test_init commit_symlink`
1066 3d9a4ec4 2020-07-23 stsp
1067 bd6aa359 2020-07-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1068 3d9a4ec4 2020-07-23 stsp ret="$?"
1069 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1070 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
1071 3d9a4ec4 2020-07-23 stsp return 1
1072 3d9a4ec4 2020-07-23 stsp fi
1073 3d9a4ec4 2020-07-23 stsp
1074 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s alpha alpha.link)
1075 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s epsilon epsilon.link)
1076 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1077 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s ../beta epsilon/beta.link)
1078 bd6aa359 2020-07-23 stsp (cd $testroot/wt && ln -s nonexistent nonexistent.link)
1079 bd6aa359 2020-07-23 stsp (cd $testroot/wt && got add alpha.link epsilon.link passwd.link \
1080 bd6aa359 2020-07-23 stsp epsilon/beta.link nonexistent.link > /dev/null)
1081 bd6aa359 2020-07-23 stsp
1082 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -m 'test commit_symlink' \
1083 35213c7c 2020-07-23 stsp > $testroot/stdout 2> $testroot/stderr)
1084 35213c7c 2020-07-23 stsp ret="$?"
1085 35213c7c 2020-07-23 stsp if [ "$ret" == "0" ]; then
1086 35213c7c 2020-07-23 stsp echo "got commit succeeded unexpectedly" >&2
1087 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1088 35213c7c 2020-07-23 stsp return 1
1089 35213c7c 2020-07-23 stsp fi
1090 35213c7c 2020-07-23 stsp echo -n "got: $testroot/wt/passwd.link: " > $testroot/stderr.expected
1091 35213c7c 2020-07-23 stsp echo "symbolic link points outside of paths under version control" \
1092 35213c7c 2020-07-23 stsp >> $testroot/stderr.expected
1093 35213c7c 2020-07-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
1094 35213c7c 2020-07-23 stsp ret="$?"
1095 35213c7c 2020-07-23 stsp if [ "$ret" != "0" ]; then
1096 35213c7c 2020-07-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
1097 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1098 35213c7c 2020-07-23 stsp return 1
1099 35213c7c 2020-07-23 stsp fi
1100 bd6aa359 2020-07-23 stsp
1101 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1102 35213c7c 2020-07-23 stsp > $testroot/stdout)
1103 35213c7c 2020-07-23 stsp
1104 bd6aa359 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1105 bd6aa359 2020-07-23 stsp echo "A alpha.link" > $testroot/stdout.expected
1106 bd6aa359 2020-07-23 stsp echo "A epsilon.link" >> $testroot/stdout.expected
1107 bd6aa359 2020-07-23 stsp echo "A nonexistent.link" >> $testroot/stdout.expected
1108 bd6aa359 2020-07-23 stsp echo "A passwd.link" >> $testroot/stdout.expected
1109 bd6aa359 2020-07-23 stsp echo "A epsilon/beta.link" >> $testroot/stdout.expected
1110 bd6aa359 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1111 bd6aa359 2020-07-23 stsp
1112 3d9a4ec4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1113 3d9a4ec4 2020-07-23 stsp ret="$?"
1114 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1115 3d9a4ec4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1116 3d9a4ec4 2020-07-23 stsp test_done "$testroot" "$ret"
1117 3d9a4ec4 2020-07-23 stsp return 1
1118 3d9a4ec4 2020-07-23 stsp fi
1119 3d9a4ec4 2020-07-23 stsp
1120 bd6aa359 2020-07-23 stsp # verify created in-repository tree
1121 bd6aa359 2020-07-23 stsp got checkout $testroot/repo $testroot/wt2 > /dev/null
1122 3d9a4ec4 2020-07-23 stsp ret="$?"
1123 3d9a4ec4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1124 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1125 bd6aa359 2020-07-23 stsp return 1
1126 3d9a4ec4 2020-07-23 stsp fi
1127 bd6aa359 2020-07-23 stsp check_symlinks $testroot/wt2
1128 bd6aa359 2020-07-23 stsp ret="$?"
1129 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1130 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1131 bd6aa359 2020-07-23 stsp return 1
1132 bd6aa359 2020-07-23 stsp fi
1133 bd6aa359 2020-07-23 stsp
1134 75f0a0fb 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1135 75f0a0fb 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1136 75f0a0fb 2020-07-23 stsp test_done "$testroot" 1
1137 75f0a0fb 2020-07-23 stsp return 1
1138 75f0a0fb 2020-07-23 stsp fi
1139 75f0a0fb 2020-07-23 stsp
1140 75f0a0fb 2020-07-23 stsp # 'got update' should reinstall passwd.link as a regular file
1141 75f0a0fb 2020-07-23 stsp (cd $testroot/wt && got update > /dev/null)
1142 bd6aa359 2020-07-23 stsp check_symlinks $testroot/wt
1143 5a1fbc73 2020-07-23 stsp ret="$?"
1144 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1145 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1146 5a1fbc73 2020-07-23 stsp return 1
1147 5a1fbc73 2020-07-23 stsp fi
1148 88fb31d4 2020-07-23 stsp
1149 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf beta alpha.link)
1150 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sfh gamma epsilon.link)
1151 88fb31d4 2020-07-23 stsp rm $testroot/wt/epsilon/beta.link
1152 88fb31d4 2020-07-23 stsp echo "this is a regular file" > $testroot/wt/epsilon/beta.link
1153 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf .got/bar dotgotbar.link)
1154 35213c7c 2020-07-23 stsp (cd $testroot/wt && got add dotgotbar.link > /dev/null)
1155 88fb31d4 2020-07-23 stsp (cd $testroot/wt && got rm nonexistent.link > /dev/null)
1156 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf gamma/delta zeta.link)
1157 88fb31d4 2020-07-23 stsp (cd $testroot/wt && ln -sf alpha new.link)
1158 88fb31d4 2020-07-23 stsp (cd $testroot/wt && got add new.link > /dev/null)
1159 88fb31d4 2020-07-23 stsp
1160 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -m 'test commit_symlink' \
1161 35213c7c 2020-07-23 stsp > $testroot/stdout 2> $testroot/stderr)
1162 35213c7c 2020-07-23 stsp ret="$?"
1163 35213c7c 2020-07-23 stsp if [ "$ret" == "0" ]; then
1164 35213c7c 2020-07-23 stsp echo "got commit succeeded unexpectedly" >&2
1165 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1166 35213c7c 2020-07-23 stsp return 1
1167 35213c7c 2020-07-23 stsp fi
1168 35213c7c 2020-07-23 stsp echo -n "got: $testroot/wt/dotgotbar.link: " > $testroot/stderr.expected
1169 35213c7c 2020-07-23 stsp echo "symbolic link points outside of paths under version control" \
1170 35213c7c 2020-07-23 stsp >> $testroot/stderr.expected
1171 35213c7c 2020-07-23 stsp cmp -s $testroot/stderr.expected $testroot/stderr
1172 35213c7c 2020-07-23 stsp ret="$?"
1173 35213c7c 2020-07-23 stsp if [ "$ret" != "0" ]; then
1174 35213c7c 2020-07-23 stsp diff -u $testroot/stderr.expected $testroot/stderr
1175 35213c7c 2020-07-23 stsp test_done "$testroot" "$ret"
1176 35213c7c 2020-07-23 stsp return 1
1177 35213c7c 2020-07-23 stsp fi
1178 88fb31d4 2020-07-23 stsp
1179 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1180 35213c7c 2020-07-23 stsp > $testroot/stdout)
1181 35213c7c 2020-07-23 stsp
1182 88fb31d4 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1183 35213c7c 2020-07-23 stsp echo "A dotgotbar.link" > $testroot/stdout.expected
1184 35213c7c 2020-07-23 stsp echo "A new.link" >> $testroot/stdout.expected
1185 88fb31d4 2020-07-23 stsp echo "M alpha.link" >> $testroot/stdout.expected
1186 88fb31d4 2020-07-23 stsp echo "M epsilon/beta.link" >> $testroot/stdout.expected
1187 88fb31d4 2020-07-23 stsp echo "M epsilon.link" >> $testroot/stdout.expected
1188 88fb31d4 2020-07-23 stsp echo "D nonexistent.link" >> $testroot/stdout.expected
1189 88fb31d4 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1190 88fb31d4 2020-07-23 stsp
1191 88fb31d4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1192 88fb31d4 2020-07-23 stsp ret="$?"
1193 88fb31d4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1194 88fb31d4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1195 88fb31d4 2020-07-23 stsp test_done "$testroot" "$ret"
1196 88fb31d4 2020-07-23 stsp return 1
1197 88fb31d4 2020-07-23 stsp fi
1198 88fb31d4 2020-07-23 stsp
1199 88fb31d4 2020-07-23 stsp got tree -r $testroot/repo -c $head_rev -R > $testroot/stdout
1200 88fb31d4 2020-07-23 stsp cat > $testroot/stdout.expected <<EOF
1201 88fb31d4 2020-07-23 stsp alpha
1202 88fb31d4 2020-07-23 stsp alpha.link@ -> beta
1203 88fb31d4 2020-07-23 stsp beta
1204 35213c7c 2020-07-23 stsp dotgotbar.link@ -> .got/bar
1205 88fb31d4 2020-07-23 stsp epsilon/
1206 88fb31d4 2020-07-23 stsp epsilon/beta.link
1207 88fb31d4 2020-07-23 stsp epsilon/zeta
1208 88fb31d4 2020-07-23 stsp epsilon.link@ -> gamma
1209 88fb31d4 2020-07-23 stsp gamma/
1210 88fb31d4 2020-07-23 stsp gamma/delta
1211 88fb31d4 2020-07-23 stsp new.link@ -> alpha
1212 88fb31d4 2020-07-23 stsp passwd.link@ -> /etc/passwd
1213 88fb31d4 2020-07-23 stsp EOF
1214 88fb31d4 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1215 88fb31d4 2020-07-23 stsp ret="$?"
1216 88fb31d4 2020-07-23 stsp if [ "$ret" != "0" ]; then
1217 88fb31d4 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1218 88fb31d4 2020-07-23 stsp fi
1219 88fb31d4 2020-07-23 stsp test_done "$testroot" "$ret"
1220 5a1fbc73 2020-07-23 stsp }
1221 5a1fbc73 2020-07-23 stsp
1222 5a1fbc73 2020-07-23 stsp function test_commit_fix_bad_symlink {
1223 5a1fbc73 2020-07-23 stsp local testroot=`test_init commit_fix_bad_symlink`
1224 5a1fbc73 2020-07-23 stsp
1225 5a1fbc73 2020-07-23 stsp got checkout $testroot/repo $testroot/wt > /dev/null
1226 5a1fbc73 2020-07-23 stsp ret="$?"
1227 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1228 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1229 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1230 5a1fbc73 2020-07-23 stsp return 1
1231 5a1fbc73 2020-07-23 stsp fi
1232 5a1fbc73 2020-07-23 stsp
1233 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1234 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && got add passwd.link > /dev/null)
1235 5a1fbc73 2020-07-23 stsp
1236 35213c7c 2020-07-23 stsp (cd $testroot/wt && got commit -S -m 'commit bad symlink' \
1237 35213c7c 2020-07-23 stsp > $testroot/stdout)
1238 5a1fbc73 2020-07-23 stsp
1239 75f0a0fb 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1240 75f0a0fb 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1241 75f0a0fb 2020-07-23 stsp test_done "$testroot" 1
1242 75f0a0fb 2020-07-23 stsp return 1
1243 75f0a0fb 2020-07-23 stsp fi
1244 75f0a0fb 2020-07-23 stsp (cd $testroot/wt && got update >/dev/null)
1245 5a1fbc73 2020-07-23 stsp if [ -h $testroot/wt/passwd.link ]; then
1246 5a1fbc73 2020-07-23 stsp echo "passwd.link is a symlink but should be a regular file" >&2
1247 5a1fbc73 2020-07-23 stsp test_done "$testroot" "1"
1248 5a1fbc73 2020-07-23 stsp return 1
1249 5a1fbc73 2020-07-23 stsp fi
1250 5a1fbc73 2020-07-23 stsp
1251 5a1fbc73 2020-07-23 stsp # create another work tree which will contain the "bad" symlink
1252 5a1fbc73 2020-07-23 stsp got checkout $testroot/repo $testroot/wt2 > /dev/null
1253 5a1fbc73 2020-07-23 stsp ret="$?"
1254 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1255 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1256 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1257 5a1fbc73 2020-07-23 stsp return 1
1258 5a1fbc73 2020-07-23 stsp fi
1259 5a1fbc73 2020-07-23 stsp
1260 5a1fbc73 2020-07-23 stsp # change "bad" symlink back into a "good" symlink
1261 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && ln -sfh alpha passwd.link)
1262 5a1fbc73 2020-07-23 stsp
1263 5a1fbc73 2020-07-23 stsp (cd $testroot/wt && got commit -m 'fix bad symlink' \
1264 5a1fbc73 2020-07-23 stsp > $testroot/stdout)
1265 5a1fbc73 2020-07-23 stsp
1266 5a1fbc73 2020-07-23 stsp local head_rev=`git_show_head $testroot/repo`
1267 5a1fbc73 2020-07-23 stsp echo "M passwd.link" > $testroot/stdout.expected
1268 5a1fbc73 2020-07-23 stsp echo "Created commit $head_rev" >> $testroot/stdout.expected
1269 5a1fbc73 2020-07-23 stsp
1270 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1271 bd6aa359 2020-07-23 stsp ret="$?"
1272 bd6aa359 2020-07-23 stsp if [ "$ret" != "0" ]; then
1273 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1274 bd6aa359 2020-07-23 stsp test_done "$testroot" "$ret"
1275 bd6aa359 2020-07-23 stsp return 1
1276 bd6aa359 2020-07-23 stsp fi
1277 5a1fbc73 2020-07-23 stsp
1278 5a1fbc73 2020-07-23 stsp if ! [ -h $testroot/wt/passwd.link ]; then
1279 5a1fbc73 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1280 5a1fbc73 2020-07-23 stsp test_done "$testroot" 1
1281 5a1fbc73 2020-07-23 stsp return 1
1282 5a1fbc73 2020-07-23 stsp fi
1283 5a1fbc73 2020-07-23 stsp
1284 5a1fbc73 2020-07-23 stsp readlink $testroot/wt/passwd.link > $testroot/stdout
1285 5a1fbc73 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1286 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1287 5a1fbc73 2020-07-23 stsp ret="$?"
1288 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1289 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1290 5a1fbc73 2020-07-23 stsp return 1
1291 5a1fbc73 2020-07-23 stsp fi
1292 5a1fbc73 2020-07-23 stsp
1293 5a1fbc73 2020-07-23 stsp # Update the other work tree; the bad symlink should be fixed
1294 5a1fbc73 2020-07-23 stsp (cd $testroot/wt2 && got update > /dev/null)
1295 5a1fbc73 2020-07-23 stsp ret="$?"
1296 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1297 5a1fbc73 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
1298 5a1fbc73 2020-07-23 stsp test_done "$testroot" "$ret"
1299 5a1fbc73 2020-07-23 stsp return 1
1300 5a1fbc73 2020-07-23 stsp fi
1301 5a1fbc73 2020-07-23 stsp
1302 5a1fbc73 2020-07-23 stsp if ! [ -h $testroot/wt2/passwd.link ]; then
1303 5a1fbc73 2020-07-23 stsp echo 'passwd.link is not a symlink' >&2
1304 5a1fbc73 2020-07-23 stsp test_done "$testroot" 1
1305 5a1fbc73 2020-07-23 stsp return 1
1306 5a1fbc73 2020-07-23 stsp fi
1307 5a1fbc73 2020-07-23 stsp
1308 5a1fbc73 2020-07-23 stsp readlink $testroot/wt2/passwd.link > $testroot/stdout
1309 5a1fbc73 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
1310 5a1fbc73 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
1311 5a1fbc73 2020-07-23 stsp ret="$?"
1312 5a1fbc73 2020-07-23 stsp if [ "$ret" != "0" ]; then
1313 5a1fbc73 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
1314 5a1fbc73 2020-07-23 stsp return 1
1315 5a1fbc73 2020-07-23 stsp fi
1316 5a1fbc73 2020-07-23 stsp
1317 bd6aa359 2020-07-23 stsp test_done "$testroot" "0"
1318 1ebedb77 2019-10-19 stsp }
1319 1ebedb77 2019-10-19 stsp
1320 7fb414ae 2020-08-08 stsp test_parseargs "$@"
1321 c4296144 2019-05-09 stsp run_test test_commit_basic
1322 83a7ae6d 2019-05-10 stsp run_test test_commit_new_subdir
1323 83a7ae6d 2019-05-10 stsp run_test test_commit_subdir
1324 83a7ae6d 2019-05-10 stsp run_test test_commit_single_file
1325 83a7ae6d 2019-05-10 stsp run_test test_commit_out_of_date
1326 8ba6ba2d 2019-05-14 stsp run_test test_commit_added_subdirs
1327 ba580f68 2020-03-22 stsp run_test test_commit_deleted_subdirs
1328 f363d663 2019-05-23 stsp run_test test_commit_rejects_conflicted_file
1329 1a36436d 2019-06-10 stsp run_test test_commit_single_file_multiple
1330 4866d084 2019-07-10 stsp run_test test_commit_added_and_modified_in_same_dir
1331 e0233cea 2019-07-25 stsp run_test test_commit_path_prefix
1332 90e8619e 2019-07-25 stsp run_test test_commit_dir_path
1333 5c1e53bc 2019-07-28 stsp run_test test_commit_selected_paths
1334 916f288c 2019-07-30 stsp run_test test_commit_outside_refs_heads
1335 84792843 2019-08-09 stsp run_test test_commit_no_email
1336 6af1ccbd 2019-08-16 stsp run_test test_commit_tree_entry_sorting
1337 257add31 2020-09-09 stsp run_test test_commit_gotconfig_author
1338 aba9c984 2019-09-08 stsp run_test test_commit_gitconfig_author
1339 1ebedb77 2019-10-19 stsp run_test test_commit_xbit_change
1340 f7b97ccb 2020-04-14 stsp run_test test_commit_normalizes_filemodes
1341 e7303626 2020-05-14 stsp run_test test_commit_with_unrelated_submodule
1342 3d9a4ec4 2020-07-23 stsp run_test test_commit_symlink
1343 5a1fbc73 2020-07-23 stsp run_test test_commit_fix_bad_symlink